Unit IDS0R_p;
interface
uses
SysUtils, Math, { Delphi }
Lstruct, Lfunc;

procedure IDS0R(N :Integer; var X :Array of Real;
                var Y :Array of Real; var Y2 :Array of Real;
                var F :Array of Real; var G :Array of Real);

implementation

procedure IDS0R(N :Integer; var X :Array of Real;
                var Y :Array of Real; var Y2 :Array of Real;
                var F :Array of Real; var G :Array of Real);
var
N1,N2,K,K1,J :Integer;
H,H1,H2,R1,R2,Z :Real;
label
_1,_2,_3;
begin
N1 := N-1;
G[0] := 0.0;
F[0] := 0.0;
for K:=1 to N1 do
 begin
  K1 := K+1;
  H2 := X[K1-1]-X[K-1];
  R2 := (Y[K1-1]-Y[K-1])/H2;
  if ( K = 1 ) 
   then goto _1;
  Z := 1.0/(2.0*(H1+H2)-H1*G[J-1]);
  G[K-1] := Z*H2;
  H := 6.0*(R2-R1);
  if ( K = 2 ) 
   then H := H-H1*Y2[0];
  if ( K = N1 ) 
   then H := H-H2*Y2[N-1];
  F[K-1] := Z*(H-H1*F[J-1]);
_1:
  J := K;
  H1 := H2;
  R1 := R2;
_2:
 end;
Y2[N1-1] := F[N1-1];
N2 := N1-1;
for J:=2 to N2 do
 begin
  K := N-J;
  Y2[K-1] := F[K-1]-G[K-1]*Y2[K+0];
_3:
 end;
end;

end.
